﻿#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

void helpmenu() {
    printf("\n[そのまま入力]=キーワードを含む行を検索 [h] = ヘルプメニュー表示\n");
    printf("[ d 半角スペース キーワード] = キーワードを含む行を消去\n\n");

    printf("[ t 半角スペース キーワード] = 左端がキーワードと一致する行を検索\n");
    printf("[dt 半角スペース キーワード] = 左端がキーワードと一致する行を消去\n\n");

    printf("[s 半角スペース ファイル名] = テーブル保存　　 [e]=プログラム終了\n\n");
}

int main(int argc, char* argv[])
{
    char** ptr = NULL;
    char* tempptr = NULL;
    FILE* fp,*fp2;
    static char str[256], searchKeyword[256];
    int length = 0, checkcount = 0, flag = 0;
    unsigned long ulFileLength = 0;
    unsigned long cursor = 0, i = 0;
    unsigned long ulAllCount = 0, ulSameCount = 0;

    if (argc == 1) {
        printf("書式:yokairm.exe passwords.txt\n");

        printf("エンターキーを入力すると終了します。\n");
        getchar();
        return 0;
    }

    // passwordsオープン
    if (fopen_s(&fp, argv[1], "rt") != 0) {
        printf("Password  File %s not found.\n", argv[1]);
        _fcloseall();
        return -1;
    }
    printf("パスワードテーブル [%s] ロード成功。\n", argv[1]);

    fseek(fp, 0, SEEK_END);
    ulFileLength = ftell(fp);
    fseek(fp, 0, SEEK_SET);

    ptr = (char**)malloc(ulFileLength + 1);
    if (ptr == NULL) {
        printf("fault.\n");
        free(ptr);
        _fcloseall();
        exit(1);
    }

    // テーブルファイルからキャラクタテーブルを分離して配列へロード
    while (1) {
        ptr[cursor] = (char*)malloc(17);
        if (fgets(ptr[cursor], 16, fp) == NULL) break;
        cursor++;
    }
    fclose(fp); // 上書きのためにこの時点でファイルクローズ

    // 終端に番兵セット
    ptr[cursor][0] = '*';
    ulAllCount = cursor; // 行数をセーブ
    cursor = 0;

    // 初回はヘルプメニュー表示
    helpmenu();

    // 検索ループ開始
    while (1) {
        printf("コマンド:");
        gets_s(searchKeyword);
        
        // うっかりエンターを押した場合は即ループ戻る
        if (searchKeyword[0] == '\0') continue;
        // e入力で脱出
        if (searchKeyword[0] == 'e') break; // 未入力で脱出

        // h入力でヘルプメニュー
        if (searchKeyword[0] == 'h') {
            helpmenu();
            continue;
        }
        
        // s入力でファイル保存
        if (searchKeyword[0] == 's' && searchKeyword[1]==' ') {
            if (fopen_s(&fp2, searchKeyword+2, "wt") != 0) {
                printf("ファイル %s の作成に失敗しました。\n", searchKeyword + 2);
                fclose(fp2);
                continue;
            }
            for (i = 0; i < ulAllCount; i++) {
                // 削除済みの行以外を出力する
                if (ptr[i][0] != 'd') {
                    fputs(ptr[i], fp2);
                }
            }
            printf("ファイル %s を保存しました。\n", searchKeyword + 2);
            fclose(fp2);
            continue;
        }

        // d単語でテーブルから情報を削除する
        if (searchKeyword[0] == 'd' && searchKeyword[1] == ' ') {
            if (searchKeyword[2] == '\0') continue; // うっかり操作防止用
            for (i = 0; i < ulAllCount; i++) {
                if (strstr(ptr[i], searchKeyword + 2)) {
                    ptr[i][0] = 'd'; ptr[i][1] = '\0'; // 冒頭dを上書きしてデリート行に定義
                }
            }
            printf("キーワード %s をテーブルから除去しました。\n", searchKeyword + 2);
            continue;
        }

        // t単語で左端から一致する単語を検索
        if (searchKeyword[0] == 't' && searchKeyword[1] == ' ') {
            cursor = 0;
            length = strlen(searchKeyword + 2); // 検索キーワード長さを探索
            while (1) {
                if (ptr[cursor][0] == '*') {
                    break; // 番兵で脱出
                }
                flag = 0;
                // 検索キーワードに該当かつデリートdを書かれていないものを出力
                for (i = 0; i < length; i++) {
                    // 不一致でフラグオン
                    if (ptr[cursor][i] != searchKeyword[i + 2]) {
                        flag = 1;
                    }
                }
                // 不一致が一文字でもあれば脱出
                if (flag) {
                    cursor++;
                    continue; 
                }
                // 表示
                if (ptr[cursor][0] != 'd') {
                    printf("%s", ptr[cursor]);
                }
                cursor++;
            }
            continue;
        }

        // dt単語で左端から一致する語を削除
        if (searchKeyword[0] == 'd' && searchKeyword[1] == 't' && searchKeyword[2]==' ') {
            cursor = 0;
            length = strlen(searchKeyword + 3); // 検索キーワード長さを探索
            while (1) {
                if (ptr[cursor][0] == '*') {
                    break; // 番兵で脱出
                }
                flag = 0;
                // 検索キーワードに該当かつデリートdを書かれていないものを出力
                for (i = 0; i < length; i++) {
                    // 不一致でフラグオン
                    if (ptr[cursor][i] != searchKeyword[i + 3]) {
                        flag = 1;
                    }
                }
                // 不一致が一文字でもあれば脱出
                if (flag) {
                    cursor++;
                    continue;
                }
                // 冒頭dを上書きしてデリート行に定義
                ptr[cursor][0] = 'd';
                ptr[cursor][1] = '\0';
                cursor++;
            }
            printf("キーワード %s をテーブルから除去しました。\n", searchKeyword + 3);
            continue;
        }
        // 通常検索でサーチ実行
        cursor = 0;
        while (1) {
            if (ptr[cursor][0] == '*') break; // 番兵で脱出
            // 検索キーワードに該当かつデリートdを書かれていないものを出力
            if (strstr(ptr[cursor], searchKeyword)) {
                if (ptr[cursor][0] != 'd') {
                    printf("%s", ptr[cursor]);
                }
            }
            cursor++;
        }
        printf("\n");

    }

    free(ptr);
    _fcloseall();
    return 0;
}