﻿#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int convert(char* str_data);

static char table[8192][16][16];

int g_iBadCount = 0;
int main(int argc, char* argv[])
{
    FILE* fp,*fp2;
    static char str[256];
    static char* ptr;
    int cursor = 0,length=0;
    

    if (argc == 1) {
        printf("usage:yokaitable.exe table.txt passwords.txt BadCount(0～13)\n");
        return 0;
    }

    // tableオープン
    if (fopen_s(&fp, argv[1], "rt") != 0) {
        printf("table  File %s not found.\n", argv[1]);
        _fcloseall();
        return -1;
    }

 
    // passwordsオープン
    if (fopen_s(&fp2, argv[2], "rt") != 0) {
        printf("Password  File %s not found.\n", argv[2]);
        _fcloseall();
        return -1;
    }

    g_iBadCount = (int)strtol(argv[3], NULL, 10);


    // テーブルファイルからキャラクタテーブルを分離して配列へ
    memset(table, NULL, sizeof(table));
    while (fgets(str, 16, fp)) {
        ptr = strstr(str, ","); // 区切り文字取得
        if (ptr == NULL) {
            printf("テーブル不正\n");
            _fcloseall();
            exit(1);
        }
        str[ptr - str] = '\0'; // 終端文字を挿入
        strcpy_s(table[cursor][0],str); // ローマ字を保存
        strcpy_s(table[cursor][1], ptr+1); // かなを保存
        length = strlen(table[cursor][1]);
        if (table[cursor][1][length - 1] == '\n') {
            table[cursor][1][length - 1] = '\0'; // 改行コードを除去
        }
        //printf("%s %s\n", table[cursor][0], table[cursor][1]);
        cursor++;
    }
    // テーブルファイル終端に番兵セット
    table[cursor][0][0] = '*';


    // 各行をローマ字→ひらがな変換しつつ
    // ひらがな以外の文字が含まれた行を除去
    while (fgets(str, 16, fp2)) {
        length = strlen(str);
        str[length - 1] = '\0'; // 改行コードを除去
        convert(str);
    }


    _fcloseall();
    return 0;
}

int convert(char* str_data) {
    static char temp[256];
    int cursor = 0;
    int i = 0, j = 0, flag = 0, badflag = 0;
    int str_length = 0;
    int table_length = 0;
    str_length = strlen(str_data);

    strcpy_s(temp, "");
    // 文字列の長さだけ処理
    badflag = 0;
    for (i = 0; i < str_length; i++) {
        cursor = 0;
        // 変換テーブルと照合処理
        while (1) {
            if (table[cursor][0][0] == '*') {
                badflag++; // うまく検出できなかった回数をカウント
                strcat_s(temp, "□"); // ダメな場合を□で穴埋め
                break; // 番兵に当たったらバッドフラグを立てて脱出
            }
            // 変換テーブルの文字列長を取得しその回数と照合し合致すれば変換
            table_length = strlen(table[cursor][0]);
            flag = 0;
            for (j = 0; j < table_length; j++) {
                if (str_data[i + j] != table[cursor][0][j]) {
                    flag=1; // 不整合フラグを加算
                }
            }
            // 合致した場合はひらがなを出力しiを加算し脱出
            if (!flag) {
                strcat_s(temp, table[cursor][1]);
                //もしくはKK,SS,TTなど連続する語を拾った場合は加算しない
                if (table[cursor][0][0] != table[cursor][0][1]) {
                    i = i + table_length - 1;
                }
                break;
            }
            cursor++;
        }
    }
    // バッドフラグカウントがBadCountと同じなら「変換成功」と見なして出力
    if (badflag==g_iBadCount) {
        printf("%s : %s\n", str_data, temp);
    }

    return 0;
}